#include<bits/stdc++.h>

using namespace std;

int main(){
   int n,m;
   cin>>n>>m;
   queue<int> a,b,t;
   int pom1,pom2,pom3;
   for(int i=0;i<m;i++)
   {
       cin>>pom1>>pom2>>pom3;
       a.push(pom1);
       b.push(pom2);
       t.push(pom3);
   }
   int u,v;
   cin>>u>>v;
   int brpaljenja=0;
   int trenutno=0;
   if(t.front()>trenutno)
   {
       brpaljenja=1;
       trenutno++;
   }
   t.pop();
   for(int i=0;i<m-1;i++)
   {
       int bibi=abs(a.front()-b.front());
       a.pop();b.pop();
       int tina=abs(a.front()-b.front());
       if(bibi<tina  || a.front()==u)
       {
           if(a.front()>=u)
           {
               if(t.front()!=trenutno)
               {
                   trenutno=t.front();
                   brpaljenja++;
               }
               u=b.front();
           }
       }
       if(u==v)
       cout<<brpaljenja<<endl;
       t.pop();
   }
   
   
    
    return 0;
}